/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	CommonDialog.h
 *
 *****************************************************************************/

// SOL++2000
// 2000.02.18

#ifndef _SOL_VIEW
#include <sol\View.h>
#endif
#include <commdlg.h>

#ifndef _SOL_COMMONDIALOG
#define _SOL_COMMONDIALOG

typedef UINT (CALLBACK* HOOKFUN)(HWND, UINT, WPARAM, LPARAM);


class CommonDialog :public View {
	static	CommonDialog* self;
	void*	calldata;

  protected:
	CommonDialog():View() {
			calldata = null;
	}

	CommonDialog(View* parent, void* data);
	~CommonDialog() { setWindow(NULL); }

	virtual Boolean create(View* parent, void* data);
	
	long	defaultProc(Event& event);
	void*	getCallData() { return calldata; }
	void	setSelf()     { self = this; }
	virtual	void popup(Action& action);

	static UINT FAR PASCAL hook(HWND hwnd, UINT message, 
				WPARAM wParam, LPARAM lParam);
};

#endif

