/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	HotKey.h
 *
 *****************************************************************************/

// SOL++2000
// 2000.02.18

#ifndef _SOL_PRIMITIVE
#include <sol\Primitive.h>
#endif

#ifndef _SOL_HOTKEY
#define _SOL_HOTKEY

class HotKey :public Primitive {
  public:
	HotKey():Primitive() { }
	HotKey(View* parent, HWND hwnd)
		  :Primitive(parent, hwnd) { }

	HotKey(View* parent, const char* name, Args& args);

	virtual Boolean create(View* parent, const char* name, Args& args);

	void	getHotKey(short* vkey, short* modifier) {
			WORD   val=(WORD)send(HKM_GETHOTKEY, 0, 0L);
        	*vkey     = LOBYTE(val);
        	*modifier = HIBYTE(val);
	}
    void	setHotKey(short vkey, short modifier) {
			send(HKM_SETHOTKEY, MAKEWORD(vkey, modifier), 0L);
	}
    void	setRules(WPARAM invalidComb, WPARAM invalidMode) {
			send(ACM_STOP, invalidComb, MAKELPARAM(invalidMode,0));
	}
};

#endif
