/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	ClassBrowser.h
 *
 *****************************************************************************/


// SOL++2000 
// 2000.02.18


#ifndef _SOL_APPLICATIONVIEW
#include <sol\ApplicationView.h>
#endif
#ifndef _SOL_DC
#include <sol\DC.h>
#endif
#ifndef _SOL_FILEDIALOG
#include <sol\FileDialog.h>
#endif
#ifndef _SOL_GENERICTREEVIEW
#include <sol\GenericTreeView.h>
#endif

#ifndef _SOL_INHERITANCETREE
#include "Inheritt.h"
#endif

#ifndef _SOL_SCROLLEDTEXT
#include <sol\ScrolledText.h>
#endif
#ifndef _SOL_FONT
#include <sol\Font.h>
#endif

#ifndef _SOL_CLASSBROWSER
#define _SOL_CLASSBROWSER

class ClassBrowser :public ApplicationView {
	Font	font;
	int		 range;
	GenericTreeView treeView;
	FileDialog		 fileDlg;
	ScrolledText	 headerFile;
	ScrolledText	 sourceFile;
  protected:
	void	select(Action& action);
	void	load(Action& action);
	long  	size(Event& event);
  public:
	ClassBrowser(Application& applet, const char* caption, Args& args);
};

#endif

