/******************************************************************************
 *
 * Copyright (c) 2000	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	ConfigDialog.h
 *
 *****************************************************************************/

// SOL++2000 Sample

// 2000/11/11

#ifndef _SOL_POPUPVIEW
#include <sol\PopupView.h>
#endif
#ifndef _SOL_STATIC
#include <sol\Static.h>
#endif
#ifndef _SOL_TEXTFIELD
#include <sol\TextField.h>
#endif
#ifndef _SOL_INTEGERFIELD
#include <sol\IntegerField.h>
#endif

#ifndef _SOL_PUSHBUTTON
#include <sol\PushButton.h>
#endif
#ifndef _SOL_FONT
#include <sol\Font.h>
#endif

#ifndef _SOL_PROXYSETTING
#define _SOL_PROXYSETTING

class ProxySetting :public PopupView {
	Static		host;
	Static		port;
	IntegerField portField;
	TextField	  hostField;
	Font		font;

	PushButton	  ok;
	PushButton	  cancel;

	char         hostName[256];

	long	size(Event& event);

public:
	ProxySetting();

	Boolean create(View* parent, const char* label, Args& args);

	~ProxySetting();
	void	setPort(int p) { portField.setInteger(p); }
	void	setHost(const char* doc) { hostField.setText(doc); }

	int		getPort() { return portField.getInteger(); }
	const char*	getHost() {
			hostField.getText(hostName, sizeof(hostName));
			return hostName;
	}	
	void	addOkCallback(View* view, Callback callback);
};

#endif
