/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	StrDef.cpp
 *
 *****************************************************************************/

// SOL++2000

// 1999.02.21 char* -> const char*

#include <sol\auxdef.h>

const char* XmNaccessMode       = "accessMode";
const char* XmNacceleratorName	= "acceleratorName";
const char* XmNacceptFiles		= "acceptFiles";
const char* XmNactivateCallback 	= "activateCallback";
const char* XmNalignment		= "alignment";
const char* XmNapplyCallback         = "applyCallback";
const char* XmNarmCallback           = "armCallback";
const char* XmNbackground		= "background";
const char* XmNbeginEditCallback = "beginEditCallback";

const char* XmNbitmap		= "bitmap";
const char* XmNborderWidth		= "borderWidth";
const char* XmNbrowseSelectionCallback = "browseSelectionCallback";
const char* XmNcancelCallback	= "cancelCallback";
const char* XmNcharSet		= "charSet";
const char* XmNchildId	      	= "childId";
const char* XmNclassName	      	= "className";
const char* XmNclassStyle		= "classStyle";
const char* XmNclipPrecision		= "clipPrecision";
const char* XmNclsExtra		= "clsExtra";
const char* XmNcolumn		= "column";
const char* XmNcursor		= "cursor";
const char* XmNcustomFilter	      	= "customFilter";
const char* XmNdataType		= "dataType";
const char* XmNdc		      	= "dc";
const char* XmNdefaultActionCallback	= "defaultActionCallback";
//const char* XmNdeleteItemCallback	    = "deleteItemCallback";

const char* XmNdialogUnit	      	= "dialogUnit";
const char* XmNdialogTitle		= "dialogTitle";
const char* XmNdirectory	      	= "directory";
const char* XmNdirection        = "direction";

const char* XmNdisableNoScroll	= "disableNoScroll";
const char* XmNdisabled		= "disabled";
const char* XmNdragBeginCallback = "dragBeginCallback";

const char* XmNdragFinishedCallback ="dragFinishedCallback";

const char* XmNendEditCallback = "endEditCallback";

const char* XmNescapement		= "escapement";
const char* XmNexposeCallback    = "exposeCallback";
const char* XmNexStyle 	   	= "exStyle";
const char* XmNextendedSel		= "extendedSel";
const char* XmNextension           	= "extension";
const char* XmNfaceName		= "faceName";
const char* XmNfileName		= "fileName";
const char* XmNfileTitle		= "fileTitle";
const char* XmNfilter	      	= "filter";
const char* XmNfilterIndex	= "filterIndex";

const char* XmNfindString		= "findString";
const char* XmNflags		      	= "flags";
const char* XmNforeground		= "foreground";
const char* XmNframe			= "frame";
//const char* XmNgetDispInfoCallback = "getDispInfoCallback";

const char* XmNgroup			= "group";
const char* XmNheight	   	= "height";
const char* XmNhelpCallback	      	= "helpCallback";
const char* XmNhook		      	= "hook";
const char* XmNhorizScrollBar	= "horizScrollBar";
const char* XmNhorizScrollCallback 	= "horizScrollCallback";
const char* XmNhorizScrollMaximum  	= "horizScrollMaximum";
const char* XmNhorizScrollMinimum  	= "horizScrollMinimum";
const char* XmNhorizThumbPosition	= "horizThumbPosition";
const char* XmNicon			= "icon";
const char* XmNiconFile		= "iconFile";
const char* XmNid 		   	= "id";
//const char* XmNinsertItemCallback = "insertItemCallback";

const char* XmNinstance		= "instance";
const char* XmNinvert		= "invert";
const char* XmNitalic		= "italic";
const char* XmNitemCount		= "itemCount";
const char* XmNitems			= "items";
const char* XmNitemsList		= "itemsList";
const char* XmNlabel		   	= "label";
const char* XmNlabelString		= "labelString";
const char* XmNlabelType		= "labelType";
const char* XmNlabelWidth		= "labelWidth";
const char* XmNlineIncrement       	= "lineIncrement";
const char* XmNloader		= "loader";
const char* XmNlogicalFont		= "logicalFont";
const char* XmNlowerCase		= "lowerCase";

const char* XmNmargin		= "margin";
const char* XmNmaximum	      	= "maximum";
const char* XmNmaxLength		= "maxLength";
const char* XmNmdiChild	      	= "mdiChild";
const char* XmNmdiClientStyle      	= "mdiClientStyle";
const char* XmNmenuCallback     	= "menuCallback";
const char* XmNmenuId	      	= "menuId";
const char* XmNmenuList		= "menuList";
const char* XmNmenuName		= "menuName";
const char* XmNminimum	      	= "minimum";
const char* XmNmultiColumn		= "multiColumn";
const char* XmNmultiLine	        = "multiLine";
const char* XmNmultipleSel		= "multipleSel";
const char* XmNnoConfiguration	= "noConfiguration";
const char* XmNnoHideSel		= "noHideSel";
const char* XmNnoPrefix		= "noPrefix";
const char* XmNoemConvert		= "oemConvert";

const char* XmNokCallback	      	= "okCallback";
const char* XmNorientation		= "orientation";
const char* XmNoutputPrecision	= "outputPrecision";
const char* XmNpageIncrement	      	= "pageIncrement";
const char* XmNparam		      	= "param";
const char* XmNpassword		= "password";
const char* XmNpattern	      	= "pattern";
const char* XmNpitchAndFamily	= "pitchAndFamily";
const char* XmNpredefined		= "predefined";
const char* XmNquality		= "quality";
const char* XmNreadOnly		= "readOnly";

const char* XmNrecomputeSize		= "recomputeSize";
const char* XmNreplaceString		= "replaceString";
const char* XmNrgbResult		= "rgbResult";
const char* XmNfileSave		= "fileSave";

// SOL++ 1.2
const char* XmNselChangeCallback = "selChangeCallback";

const char* XmNscrollBar		= "scrollBar";
const char* XmNshadow		= "shadow";
const char* XmNsortItems		= "sortItems";
const char* XmNspacing		= "spacing";
const char* XmNstrikeout		= "strikeout";
const char* XmNstyle		   	= "style";
const char* XmNtabStop		= "tabStop";
const char* XmNtemplateName  = "templateName"; 
const char* XmNthickness		="thickness";
const char* XmNthumbPosition	= "thumbPosition";
const char* XmNtype		     = "type";
const char* XmNunderline		= "underline";
const char* XmNupperCase		= "upperCase";

const char* XmNuseTabStops		= "useTabStops";

const char* XmNvertScrollBar		= "vertScrollBar";
const char* XmNvertScrollCallback  	= "vertScrollCallback";
const char* XmNvertScrollMaximum   	= "vertScrollMaximum";
const char* XmNvertScrollMinimum   	= "vertScrollMinimum";
const char* XmNvertThumbPosition	= "vertThumbPosition";
const char* XmNvalue			= "value";
const char* XmNvisible		= "visible";
const char* XmNwantKeyboardInput	= "wantKeyboardInput";
const char* XmNweight		= "weight";
const char* XmNwidth		   	= "width";
const char* XmNwindowIcon		= "windowIcon";
const char* XmNwndExtra		= "wndExtra";
const char* XmNwndProc		= "wndProc";
const char* XmNx		   	= "x";
const char* XmNy		   	= "y";

// SOL++2.0
const char* XmNfocusId        = "focusId";

const char* XmNchangeCallback = "changeCallback";
const char* XmNerrorSpaceCallback = "errorSpaceCallback";
const char* XmNkillFocusCallback = "killFocusCallback";
const char* XmNmaxTextCallback = "maxTextCallback";
const char* XmNsetFocusCallback = "setFocusCallback";
const char* XmNupdateCallback = "updateCallback";

const char* XmNcloseUpCallback = "closeUpCallback";
const char* XmNdropDownCallback = "dropDownCallback";
const char* XmNeditChangeCallback = "editChangeCallback";
const char* XmNeditUpdateCallback = "editUpdateCallback";

const char* XmNselEndCancelCallback = "selEndCancelCallback";
const char* XmNselEndOkCallback = "selEndOkCallback";

const char* XmNselCancelCallback = "selCancelCallback";


// TreeView CommonControl callbacks
const char* 	XmNgetDispInfoCallback = "getDispInfoCallback";
const char*	XmNbeginLabelEditCallback = "beginLabelEditCallback";
const char*	XmNendLabelEditCallback = "endLabelEditCallback";
const char*	XmNbeginDragCallback = "beginDragCallback";
const char*	XmNbeginRDragCallback = "beginRDragCallback";
const char*	XmNitemExpandingCallback = "itemExpandingCallback";
const char*	XmNitemExpandedCallback = "itemExpandedCallback";
const char*	XmNdeleteItemCallback = "deleteItemCallback";
const char*   XmNkeyDownCallback  = "keyDownCallback";

// PropertyDialog 
const char*	XmNstartPage         = "startPage";
const char*	XmNpages			= "pages";

// PropertySheetPage 
const char*	XmNsetActiveCallback  = "setActiveCallback";
const char*	XmNkillActiveCallback = "killActiveCallback";
const char*	XmNresetCallback   = "resetCallback";
const char*	XmNhasHelpCallback = "hasHelpCallback";
const char*	XmNwizBackCallback = "wizBackCallback";
const char*	XmNwizNextCallback = "wizNextCallback";
const char*	XmNwizFinishCallback = "wizFinishCallback";
const char*	XmNqueryCancelCallback = "queryCancelCallback";

// SOL++1.2 ListView NotifyCallback

const char* XmNitemChangingCallback 	= "itemChangingCallback";
const char* XmNitemChangedCallback  	= "itemChangedCallback";
const char* XmNinsertItemCallback   	= "insertItemCallback";
const char* XmNenableEditCallback   	= "enableEditCallback";
const char* XmNdeleteAllItemsCallback = "deleteAllItemsCallback";
const char* XmNcolumnClickCallback	= "columnClickCallback";
const char* XmNsetDispInfoCallback	= "setDispInfoCallback";

const char* XmNselChangingCallback	= "selChangingCallback";
const char* XmNselChangedCallback	    = "selChangedCallback";

// Header control 
const char* XmNitemClickCallback		= "itemClickCallback";
const char* XmNitemDoubleClickCallback	= "itemDoubleClickCallback";
const char* XmNdividerDoubleClickCallback = "dividerDoubleClickCallback";
const char* XmNbeginTrackCallback		= "beginTrackCallback";
const char* XmNendTrackCallback		= "endTrackCallback";
const char* XmNtrackCallback			= "trackCallback";

// Toolbar
const char* XmNgetButtonInfoCallback = "getButtonInfoCallback";
const char* XmNendDragCallback		= "endDragCallback";
const char* XmNbeginAdjustCallback	= "beginAdjustCallback";
const char* XmNendAdjustCallback		= "endAdjustCallback";

const char* XmNqueryInsertCallback	= "queryInsertCallback";
const char* XmNqueryDeleteCallback	= "queryDeleteCallback";

const char* XmNtoolbarChangeCallback	= "toolbarChangeCallback";
const char* XmNcustHelpCallback		= "custHelpCallback";

// Tooltips
const char* XmNneedTextCallback	= "needTextCallback";
const char* XmNpopupCallback		= "popupCallback";
const char* XmNshowCallback		= "showCallback";

// ToolBar
const char* XmNenableThumbTrack = "enableThumbTrack";
const char* XmNtoolBarBitmapID  = "toolBarBitmapID";

const char* XmNdefaultToolBar = "defaultToolBar";
const char* XmNdefaultStatusBar = "defaultStatusBar";

const char* XmNnumBitmaps		= "numBitmaps";

// RichText
const char* XmNcorrectTextCallback = "correctTextCallback";
const char* XmNdropFilesCallback   = "dropFilesCallback";
const char* XmNmsgFilterCallback   = "msgFilterCallback";
const char* XmNprotectedCallback   = "protecteCallback";
const char* XmNrequestResizeCallback = "requestResizeCallback";
const char* XmNstopNoUndoCallback    = "stopUndoCallback";


// Common notification

const char* XmNclickCallback		= "clickCallback";
const char* XmNdoubleClickCallback = "doubleClickCallback";
const char* XmNreturnCallback		= "returnCallback";
const char* XmNrightClickCallback = "rightClickCallback";
const char* XmNrightDoubleClickCallback = "rightDoubleClickCallback";

const char* XmNdeltaPosCallback = "deltaPosCallback";

// SOL++ 2.1
const char* XmNimageName  = "imageName";
const char* XmNxImageSize = "xImageSize";
const char* XmNyImageSize = "yImageSize";
const char* XmNkeyInCallback = "keyInCallback";

const char* XmNcentering  = "centering";
